/**            Test code for bug found by Niko Dybowski
 *             Forms correlation between two 3d real arrays is
 *            an infinite loop. 
 */
import jfftw.*;


public class Niko {

    public static void main(String args[]) {

	if (args.length < 3) {
	    System.out.println("Usage : java Niko x y z");
	    System.exit(1);
	}

	//              Get size
	int x = Integer.parseInt(args[0]);
	int y = Integer.parseInt(args[1]);
	int z = Integer.parseInt(args[2]);

	System.out.println("Test size is : " + x + " x " + y + " x " + z);
	
	int j = 0;
	while (true) {                 // Infinite test loop

	    RealDataArray s = new RealDataArray(x,y,z);
	    RealDataArray t = new RealDataArray(x,y,z);	

	    //             Fill both arrays with randoms

	    for(int i = 0; i < x*y*z; i++ ) {      // 1d access
		s.setDouble(i,Math.random());
		t.setDouble(i,Math.random());
	    }

	    s.fourier();                 // s forward               
	    t.fourier();                 // t forward

	    s.conjugate();              // Conj s
	    s.mult(t);                  // Product
	    s.fourier();                // Back to real space

	    

	    System.out.println("Loop " + (j++) + " : " + s );
	}

    }
}