import uk.ac.ed.ph.jfftw.*;
import ptolemy.plot.*;
/**           Simple test program to take FFT of a top-hat and
 *            plot the modulus using ptplot.
 */
public class OneDimensionalReal {

    public static void main(String args[]) {

	int len = 500;
	int w = 10;

	//          Make real signal with centred top-hat
	double[] r = new double[len];
	for(int i = (len - w)/2; i <= (len + w)/2; i++) {
	    r[i] = 1.0;
	}

	FFTWReal fft = new FFTWReal();        // Make fft object
	double[] c = fft.oneDimensionalForward(r); // Take the fft

	//            Plot out the modulus
	Plot plot = new Plot();
	for(int i = 0; i < len/2 + 1; i++) {
	    double y = ArrayUtil.getComplex(c,i).modulus();
	    plot.addPoint(0,(double)i,y,true);
	}

	//          make ptframe and display result
	PlotFrame frame = new PlotFrame("Modulus",plot);
	frame.setSize(600,400);
	frame.setVisible(true);

	
    }
}